︠1b53d535-7c24-45d6-96d1-ebd9f7ade2afi︠
%md
# **OPTIMIZANDO-CODIGOS-PARA-ALTA-PERFORMANCE**
︡e7399a70-f8cf-4162-baad-80380fb1ff96︡{"done":true,"md":"# **OPTIMIZANDO-CODIGOS-PARA-ALTA-PERFORMANCE**"}
︠45a136f5-162a-4d3a-b81d-97362a0bd9b9︠

︡1d78aff8-1f0b-4954-b30a-922ed2060e6c︡
︠ef297978-dc06-462c-9988-b7ffa3a70b45i︠
%md
## **CYTHON**

Embora o Python seja uma linguagem conveniente de alto nível, certos cálculos podem ser várias vezes mais rápidos do que em Python se eles forem implementados usando tipos estáticos em uma linguagem compilada. Alguns aspectos do Sage seriam muito lentos se eles fossem escritos inteiramente em Python. Para lidar com isso, o Sage suporta uma “versão” compilada do Python chamada Cython ([Cyt] and [Pyr]). O Cython é simultaneamente similar ao Python e ao C. A maior parte das construções em Python, incluindo “list comprehensions”, expressões condicionais, código como += são permitidos; você também pode importar código que você escreveu em outros módulos em Python. Além disso, você pode declarar variáveis em C arbitrárias, e qualquer chamada de bibliotecas em C pode ser feita diretamente. O código resultante é convertido para C e compilado usando um compilador para C
︡87ec7f3a-7bdd-436d-8679-a29a5fd81471︡{"done":true,"md":"## **CYTHON**\n\nEmbora o Python seja uma linguagem conveniente de alto nível, certos cálculos podem ser várias vezes mais rápidos do que em Python se eles forem implementados usando tipos estáticos em uma linguagem compilada. Alguns aspectos do Sage seriam muito lentos se eles fossem escritos inteiramente em Python. Para lidar com isso, o Sage suporta uma “versão” compilada do Python chamada Cython ([Cyt] and [Pyr]). O Cython é simultaneamente similar ao Python e ao C. A maior parte das construções em Python, incluindo “list comprehensions”, expressões condicionais, código como += são permitidos; você também pode importar código que você escreveu em outros módulos em Python. Além disso, você pode declarar variáveis em C arbitrárias, e qualquer chamada de bibliotecas em C pode ser feita diretamente. O código resultante é convertido para C e compilado usando um compilador para C"}
︠ce76fb3a-bee7-4690-b841-e88e4981c8ccs︠
reset()
︡fbbe4725-6427-4d52-99fe-6711e6e435d1︡{"done":true}︡
︠a9aba7e0-3a4a-4521-9c2c-4ce0e54ec12ci︠
%html
<p>Execu&ccedil;&atilde;o da serie de fibonacci para o termo 35</p>
<table style="width: 1438px; height: 66px;" border="0">
<tbody>
<tr style="height: 0px;">
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">
<p>Julia</p>
</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Python (jupyter)</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Sage</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Sage (Cython)</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">C(terminal)</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Octave(GUI)</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Scilab(GUI)</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Maxima(GUI)</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">Matlab</td>
</tr>
<tr style="height: 0px;">
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">&nbsp;0.094s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">&nbsp;3.302s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">&nbsp;5.720s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">0.66s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">0.034s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">&nbsp;322.918s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">
<p>&nbsp; 60.067</p>
</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">&nbsp;98.350s</td>
<td style="border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;">&nbsp;</td>
</tr>
</tbody>
</table>

︡17ba2abb-2ba9-42b2-9fd7-819a2eea00fb︡{"html": "<p>Execu&ccedil;&atilde;o da serie de fibonacci para o termo 35</p>\n<table style=\"width: 1438px; height: 66px;\" border=\"0\">\n<tbody>\n<tr style=\"height: 0px;\">\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">\n<p>Julia</p>\n</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Python (jupyter)</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Sage</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Sage (Cython)</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">C(terminal)</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Octave(GUI)</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Scilab(GUI)</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Maxima(GUI)</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">Matlab</td>\n</tr>\n<tr style=\"height: 0px;\">\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">&nbsp;0.094s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">&nbsp;3.302s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">&nbsp;5.720s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">0.66s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">0.034s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">&nbsp;322.918s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">\n<p>&nbsp; 60.067</p>\n</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">&nbsp;98.350s</td>\n<td style=\"border-color: #000000; width: 0px; height: 0px; border-style: solid; border-width: 1px;\">&nbsp;</td>\n</tr>\n</tbody>\n</table>"}︡
︠8ee558a8-5a0b-4816-9405-e396853b2ea2s︠
def fiboR_SG_NORMAL(n):
    if n < 2:
        return n
    else:
        return fiboR_SG_NORMAL(n-1) + fiboR_SG_NORMAL(n-2)
︡e8ec24fe-c41f-47f5-8438-c1cf1ecfce61︡{"done":true}︡
︠3c027194-91f7-404a-a9cf-358386fb7e1as︠
%time

fiboR_SG_NORMAL(35)
︡76264125-96a0-4549-8421-1496504f02ab︡{"stdout":"9227465"}︡{"stdout":"\n"}︡{"stdout":"CPU time: 9.19 s, Wall time: 9.45 s\n"}︡{"done":true}︡
︠fd081872-9905-4ada-a347-e734999b2ebas︠
%cython
# ao colocar int no parametro passado como valor é produzido uma otimização de código fantástica, pois aproxima do código em C

def fiboR_SG_CYTHON(int n):
    if n < 2:
        return n
    else:
        return fiboR_SG_CYTHON(n-1) + fiboR_SG_CYTHON(n-2)
︡447485bc-504e-452a-881f-fb037b600fb1︡{"stdout":"Defined fiboR_SG_CYTHON"}︡{"stdout":"\n"}︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/25038/spyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_keAmGv_a_pyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_keAmGv_a_pyx_0.html","show":true,"text":"Auto-generated code...","url":"/c866c77f-ee7b-4d60-a777-22d3492d10b1/raw/.sage/temp/compute1-us/25038/spyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_keAmGv_a_pyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_keAmGv_a_pyx_0.html"},"once":false}︡{"done":true}︡
︠375eae13-b2fe-4e6b-9be8-cdf27375d8ees︠
%time

fiboR_SG_CYTHON(35)
︡d7afc790-3b76-4312-8a90-3d8247ba191d︡{"stdout":"9227465"}︡{"stdout":"\n"}︡{"stdout":"CPU time: 0.64 s, Wall time: 0.64 s\n"}︡{"done":true}︡
︠2f5e0915-1b26-4641-9b7b-8f077c433f2ai︠
%md
Altere o nome do arquivo contendo o codigo python de ".py" para ".spyx" e importe o arquivo ".spyx" e execute

︡537d4fd9-0c96-4bce-8d4c-310ccb478614︡{"done":true,"md":"Altere o nome do arquivo contendo o codigo python de \".py\" para \".spyx\" e importe o arquivo \".spyx\" e execute"}
︠dde3f7ad-7b08-46cf-95d6-b75a79042428s︠
load("fiboR_SG.spyx")
︡3d5f069d-909c-4e2a-81ef-f6abcdc2c5a2︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py\", line 947, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_salvus.py\", line 3310, in load\n    exec 'salvus.namespace[\"%s\"] = sage.structure.sage_object.load(*__args, **__kwds)'%t in salvus.namespace, {'__args':other_args, '__kwds':kwds}\n  File \"<string>\", line 1, in <module>\n  File \"sage/structure/sage_object.pyx\", line 965, in sage.structure.sage_object.load (/projects/sage/sage-dev/src/build/cythonized/sage/structure/sage_object.c:11164)\n    sage.repl.load.load(filename, globals())\n  File \"/projects/sage/sage-dev/local/lib/python2.7/site-packages/sage/repl/load.py\", line 263, in load\n    raise IOError('did not find file %r to load or attach' % filename)\nIOError: did not find file 'fiboR_SG.spyx' to load or attach\n"}︡{"done":true}︡
︠24bb9589-a4c4-4928-b381-2f6247ee788b︠
%time

fiboR_SG(35)
︡924c342f-9c5a-4007-af4f-359043edca08︡{"tex": {"tex": "\\newcommand{\\Bold}[1]{\\mathbf{#1}}9227465", "display": true}}︡{"stdout": "CPU time: 0.66 s,  Wall time: 0.67 s"}︡
︠7d097643-deda-4aeb-a57f-0443c6f6a0b5i︠
%html
<p>Outro exemplo</p>

<p>Calcular a integral de: $ f(x) = x^{2}$</p>

︡f38b8999-4bc8-49b0-bb03-1c8a385466e6︡{"html": "<p>Outro exemplo</p>\n\n<p>Calcular a integral de: $ f(x) = x^{2}$</p>"}︡
︠2b179b07-4e02-47a7-924a-aee8d536a455︠
plot(x^2-x,(x,0,10),figsize=(4, 3),fill=True)
︡8df0def7-aeb7-4edc-9059-5484b9d1ba95︡︡
︠53e6b96b-08f5-4f2a-9f44-2ea34bece321s︠
integrate(x^2,x,0,5).n()
︡8cb81987-a0f3-4895-8a20-859f7544fc31︡{"stdout":"41.6666666666667\n"}︡{"done":true}︡
︠2f40e037-9136-4c5f-affb-903ec7cc8689i︠

%md
Integra&ccedil;&atilde;o por metodo do trapezio entre os intervalos 0 a 5 e N = 500000

︡489c2489-b188-4294-a72e-0eb8b6df690e︡{"done":true,"md":"Integra&ccedil;&atilde;o por metodo do trapezio entre os intervalos 0 a 5 e N = 500000"}
︠79b4005c-113c-4827-9f50-808709b8c14as︠
def integral_NORMAL(fun,a, b, N):
    s = 0
    dx = (b-a)/N
    for i in range(N):
        s = s + fun(a+i*dx)
    return n(s*dx)
︡1f38ed4f-7196-46ef-8b4e-8210ba042fe0︡{"done":true}︡
︠20dbc984-62a2-4c05-b5f5-5c4823a4868as︠
%time

integral_NORMAL(x^2,0,5,700000)
︡1f514e8a-5a55-4caa-b093-d276962294e8︡{"stdout":"41.6665773809949"}︡{"stdout":"\n"}︡{"stderr":"<string>:1: DeprecationWarning: Substitution using function-call syntax and unnamed arguments is deprecated and will be removed from a future release of Sage; you can use named arguments instead, like EXPR(x=..., y=...)\nSee http://trac.sagemath.org/5930 for details.\n"}︡{"stdout":"CPU time: 38.55 s, Wall time: 38.79 s\n"}︡{"done":true}︡
︠30cebf35-35e2-4383-a19b-19f285353eadi︠
%html
<p>Compilando com o Cython</p>

︡e6e00cf6-3fa5-40a8-9743-392022e7ecb8︡{"html": "<p>Compilando com o Cython</p>"}︡
︠0e90508e-fab0-4dd4-a11a-c3441132cafbs︠
%cython

def integral_CYTHON(fun,float a, float b, int N):
    s = 0
    dx = (b-a)/N
    for i in range(N):
        s = s + fun(a+i*dx)
    return (s*dx)
︡85bb39c8-c336-4c89-81c1-147460f7ee49︡{"stdout":"Defined integral_CYTHON"}︡{"stdout":"\n"}︡{"file":{"filename":"/projects/c866c77f-ee7b-4d60-a777-22d3492d10b1/.sage/temp/compute1-us/25038/spyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_oZbaXb_a_pyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_oZbaXb_a_pyx_0.html","show":true,"text":"Auto-generated code...","url":"/c866c77f-ee7b-4d60-a777-22d3492d10b1/raw/.sage/temp/compute1-us/25038/spyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_oZbaXb_a_pyx/_projects_c866c77f_ee7b_4d60_a777_22d3492d10b1__sage_temp_compute1_us_25038_dir_oZbaXb_a_pyx_0.html"},"once":false}︡{"done":true}︡
︠b8054891-9760-4a61-93bf-c0508682b041s︠
%time

integral_CYTHON(x^2,0,5,700000)
︡79b01d9a-d7a5-4460-89f5-0a441b999c1c︡{"stdout":"41.666577633835004"}︡{"stdout":"\n"}︡{"stderr":"/usr/local/lib/python2.7/dist-packages/smc_sagews/sage_server.py:957: DeprecationWarning: Substitution using function-call syntax and unnamed arguments is deprecated and will be removed from a future release of Sage; you can use named arguments instead, like EXPR(x=..., y=...)\nSee http://trac.sagemath.org/5930 for details.\n  exec compile(block+'\\n', '', 'single') in namespace, locals\n"}︡{"stdout":"CPU time: 27.71 s, Wall time: 28.86 s\n"}︡{"done":true}︡
︠d8d63108-b7d1-4d8e-9e6f-8d25c8a95809i︠
%md
## **Numba**
︡514fa6c7-d4ca-42ad-9337-507bd5fb1639︡{"done":true,"md":"## **Numba**"}
︠49b0e626-16b4-437e-bf23-b93d5cf18fe7︠









